;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: CPUSTUB.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_2AA7:near

	public	FORCEBIG
	public	EndOfCode

; This is to force WORD/DWORD size immediate values in instructions,
; where the value would fit into BYTE/WORD
FORCEBIG	equ	0


		db '@(#)cpustub.asm',TAB,'3.'
 IF VPCI GE 'p'
		db '4',0
 ELSE
		db '3',0
 ENDIF
		ALIGN0	32

		push	EXCP_INVALIDOP
		push	0
		jmp	loc_2AA7

		db 13h dup(0)
 IF VPCI GE 'p'
		db 'ASRD'
 ELSE
		db 4 dup(0)
 ENDIF

EndOfCode:	db 0Fh dup(0)		; DATA XREF: 0227

hypseg		ends
		end

;------------------------------------------------------------- end CPUSTUB.ASM