;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FYL2X.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	loc_8E80:near
	extrn	loc_8E99:near
	extrn	loc_8F23:near
	extrn	loc_8F44:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FF4:near
	extrn	loc_9068:near
	extrn	loc_9097:near

	public	DecFYL2XP1
	public	DecFYL2X

		db '@(#)fyl2x.asm',TAB,'3.2',0
		ALIGN0	32

loc_9A60:	dt 0BFFDC4D6BC5142E67459h	; -0.384451

loc_9A6A:	dt 3FFAA8C8744AA35BB088h	; 0.0412068

loc_9A74:	dt 0BFF58BAD1F2D3EE1C1CAh	; -0.00106565

loc_9A7E:	dt 0BFFDA603364085D6E0CDh	; -0.324243

loc_9A88:	dt 3FFAC02D68501BC367AEh	; 0.0469183

loc_9A92:	dt 0BFF68C6C0BCC02A535CDh	; -0.00214267

loc_9A9C:	dt 3FEEFB7A2D250B9D992Eh	; 1.49892e-005

loc_9AA6:	dt 3FFEB17217F7D1CF79ACh	; 0.693147 = ln(2)

SqrtTwo:	dt 3FFFB504F333F9DE6485h	; 1.41421 = SQRT(2)

loc_9ABA:	dt 7FFF8000000000000000h	; +INF


DecFYL2XP1:	mov	byte ptr [ebp-0AFh], 1
		jmp	short loc_9AD4

DecFYL2X:	mov	byte ptr [ebp-0AFh], 0
loc_9AD4:	@CALL	loc_8E80
		sub	esp, 0B9h
		mov	ecx, h_base[ebp]
		mov	byte ptr [ebp-86h], 0
		mov	byte ptr [ebp-85h], 0
		mov	word ptr [ebp-0B5h], 0
		fnsave	byte ptr h_fenviron[ebp]
		FNLDSW	h_fsw[ebp]
		FNLDTW	h_ftw[ebp]
		btr	dword ptr h_fsw[ebp], 0Ah
		ffree	st(6)
		ffree	st(7)
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2
		jz	short loc_9B28
		mov	byte ptr [ebp-85h], 1
loc_9B28:	sahf	
		jbe	short loc_9B63
		jnp	short loc_9BA3
		fabs	
		fld1	
		fcomp	st(1)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 40h
		jnz	short loc_9B4E
		mov	byte ptr [ebp-86h], 1
		jmp	loc_9BCC

loc_9B4E:	mov	byte ptr [ebp-86h], 4
		test	byte ptr [ebp-85h], 1
		jnz	short loc_9BD5
		jmp	loc_9C1C

loc_9B63:	jc	short loc_9B8A
		jp	short loc_9BAC
		mov	byte ptr [ebp-86h], 3
		test	byte ptr [ebp-0AFh], 1
		jz	loc_9C03
		test	byte ptr [ebp-85h], 1
		jz	loc_9C1C
		jmp	short loc_9C03

loc_9B8A:	jp	loc_9C0C
		jz	short loc_9B9E
		mov	byte ptr [ebp-86h], 5
		jmp	loc_9C1C

loc_9B9E:	jmp	loc_9CC5

loc_9BA3:	mov	byte ptr [ebp-86h], 6
		jmp	short loc_9C1C

loc_9BAC:	mov	byte ptr [ebp-86h], 2
		@CALL	loc_8E99
		mov	[ebp-0B5h], dx
		fld	st
		fstp	tbyte ptr [ebp-0A4h]
loc_9BCC:	test	byte ptr [ebp-85h], 1
		jz	short loc_9BE7
loc_9BD5:	test	byte ptr [ebp-0AFh], 1
		jnz	short loc_9C03
		or	byte ptr [ebp-85h], 8
		jmp	short loc_9C1C

loc_9BE7:	fld1	
		fcomp	st(1)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 1
		jnz	short loc_9C1C
		test	byte ptr [ebp-0AFh], 1
		jnz	short loc_9C1C
loc_9C03:	or	byte ptr [ebp-85h], 4
		jmp	short loc_9C1C

loc_9C0C:	test	byte ptr [ebp-85h], 1
		jz	short loc_9C1C
		or	byte ptr [ebp-85h], 8
loc_9C1C:	fstp	st
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2
		jz	short loc_9C36
		or	byte ptr [ebp-85h], 2
loc_9C36:	sahf	
		jbe	short loc_9C73
		jnp	loc_9D3C
		test	byte ptr [ebp-85h], 8
		jnz	loc_9DE1
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_9C65[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_9C65:	dw small offset loc_9D5A
		dw small offset loc_9E1B
		dw small offset loc_9E11
		dw small offset loc_9D7A
		dw small offset loc_9DB3
		dw small offset loc_9D4B
		dw small offset loc_9D3C

loc_9C73:	jc	short loc_9CAF
		jp	loc_9D08
		test	byte ptr [ebp-85h], 8
		jnz	loc_9DE1
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_9CA1[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_9CA1:	dw small offset loc_9DE1
		dw small offset loc_9DA5
		dw small offset loc_9D9B
		dw small offset loc_9DBE
		dw small offset loc_9DA5
		dw small offset loc_9D4B
		dw small offset loc_9D3C

loc_9CAF:	jp	short loc_9CD4
		jz	short loc_9CC5
loc_9CB3:	fld	tbyte ptr h_fr0[ebp]
		@CALL	loc_8FF4
		jmp	loc_A064

loc_9CC5:	@CALL	loc_9068
		jmp	loc_A07B

loc_9CD4:	test	byte ptr [ebp-85h], 8
		jnz	loc_9DE1
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_9CFA[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_9CFA:	dw small offset loc_9D5A
		dw small offset loc_9D5A
		dw small offset loc_9D50
		dw small offset loc_9DC9
		dw small offset loc_9DD4
		dw small offset loc_9D4B
		dw small offset loc_9D3C

loc_9D08:	test	byte ptr [ebp-85h], 8
		jnz	loc_9DE1
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_9D2E[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_9D2E:	dw small offset loc_9D50
		dw small offset loc_9E11
		dw small offset loc_9E11
		dw small offset loc_9D65
		dw small offset loc_9DA9
		dw small offset loc_9D4B
		dw small offset loc_9D3C

loc_9D3C:	@CALL	loc_8FB3
		jmp	loc_A064

loc_9D4B:	jmp	loc_9CB3

loc_9D50:	@CALL	loc_9097
loc_9D5A:	fld	tbyte ptr ds:loc_9ABA[ecx]
		jmp	loc_9DF0

loc_9D65:	test	byte ptr [ebp-0AFh], 1
		jz	short loc_9D7A
		@CALL	loc_9097
		jmp	short loc_9DA5

loc_9D7A:	test	byte ptr [ebp-0AFh], 1
		jnz	short loc_9DA5
		bts	dword ptr h_fsw[ebp], 2
		bt	dword ptr h_fcw[ebp], 2
		jnc	short loc_9D91
		jmp	short loc_9D5A

loc_9D91:	@CALL	loc_8F44
loc_9D9B:	@CALL	loc_9097
loc_9DA5:	fldz	
		jmp	short loc_9DF0

loc_9DA9:	@CALL	loc_9097
loc_9DB3:	test	byte ptr [ebp-0AFh], 1
		jnz	short loc_9E1B
		jmp	short loc_9DA5

loc_9DBE:	test	byte ptr [ebp-0AFh], 1
		jnz	short loc_9DA5
		jmp	short loc_9DE1

loc_9DC9:	test	byte ptr [ebp-0AFh], 1
		jz	short loc_9D5A
		jmp	short loc_9DE1

loc_9DD4:	test	byte ptr [ebp-0AFh], 1
		jnz	loc_9D5A
loc_9DE1:	@CALL	loc_8FB3
		jmp	loc_A064

loc_9DF0:	fstp	tbyte ptr h_ftemp[ebp]
		mov	al, [ebp-85h]
		shl	al, 1
		xor	al, [ebp-85h]
		shl	al, 5
		and	al, 80h
		or	h_ftemp[ebp+9], al
		fld	tbyte ptr h_ftemp[ebp]
		jmp	loc_A064

loc_9E11:	@CALL	loc_9097
loc_9E1B:	fninit	
		fld	tbyte ptr h_fr1[ebp]
		fld	tbyte ptr h_fr0[ebp]
		fstp	tbyte ptr h_ftemp[ebp]
		fstp	tbyte ptr [ebp-84h]
		cmp	byte ptr [ebp-0AFh], 1
		jnz	short loc_9E42
		fldz	
		fstp	tbyte ptr [ebp-9Ah]
		fld	tbyte ptr h_ftemp[ebp]
		jmp	short loc_9EB9

loc_9E42:	mov	ax, h_ftemp[ebp+8]
		sub	ax, 3FFFh
		mov	[ebp-9Ah], ax
		fild	word ptr [ebp-9Ah]
		cmp	byte ptr [ebp-86h], 2
		jz	short loc_9E6B
		fld	tbyte ptr h_ftemp[ebp]
		fstp	tbyte ptr [ebp-0A4h]
		jmp	short loc_9E75

loc_9E6B:	fisub	word ptr [ebp-0B5h]
		fld1	
		faddp	st(1), st
loc_9E75:	fstp	tbyte ptr [ebp-9Ah]
		mov	word ptr [ebp-9Ch], 3FFFh
		fld	tbyte ptr [ebp-0A4h]
		fld	tbyte ptr ds:SqrtTwo[ecx]
		fcomp	st(1)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnc	short loc_9EB5
		fld	tbyte ptr [ebp-9Ah]
		fld1	
		faddp	st(1), st
		fstp	tbyte ptr [ebp-9Ah]
		fld1	
		fadd	st, st
		fdivp	st(1), st
loc_9EB5:	fld1	
		fsubp	st(1), st
loc_9EB9:	fld1	
		fadd	st, st
		fst	st(2)
		fadd	st, st(1)
		fdivp	st(1), st
		fmulp	st(1), st
		fst	st(1)
		fstp	tbyte ptr [ebp-0AEh]
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_9EFA
		jp	short loc_9EFA
		fld	tbyte ptr [ebp-9Ah]
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_9EF5
		fstp	st
loc_9EF5:	jmp	loc_9F9B

loc_9EFA:	btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
		mov	ax, [ebp-0A6h]
		and	ax, 7FFFh
		cmp	ax, 3FBFh
		jge	short loc_9F22
		fld	tbyte ptr ds:loc_9AA6[ecx]
		fclex	
		fdivp	st(1), st
		jmp	short loc_9F9B

loc_9F22:	fst	st(1)
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_9A74[ecx]
		fld	st(1)
		fmulp	st(1), st
		fld	tbyte ptr ds:loc_9A6A[ecx]
		faddp	st(1), st
		fld	st(1)
		fmulp	st(1), st
		fld	tbyte ptr ds:loc_9A60[ecx]
		faddp	st(1), st
		fld	st(1)
		fmulp	st(1), st
		fld	st(2)
		fmulp	st(1), st
		fxch	st(2)
		fxch	st(1)
		fld	tbyte ptr ds:loc_9A9C[ecx]
		fld	st(1)
		fmulp	st(1), st
		fld	tbyte ptr ds:loc_9A92[ecx]
		faddp	st(1), st
		fld	st(1)
		fmulp	st(1), st
		fld	tbyte ptr ds:loc_9A88[ecx]
		faddp	st(1), st
		fld	st(1)
		fmulp	st(1), st
		fld	tbyte ptr ds:loc_9A7E[ecx]
		faddp	st(1), st
		fld	st(1)
		fmulp	st(1), st
		fstp	st(1)
		fxch	st(2)
		faddp	st(1), st
		fxch	st(1)
		fld	tbyte ptr ds:loc_9AA6[ecx]
		faddp	st(1), st
		fdivp	st(1), st
		fld	tbyte ptr [ebp-9Ah]
		fclex	
		faddp	st(1), st
loc_9F9B:	fld	tbyte ptr [ebp-84h]
		mov	ax, h_fcw[ebp]
		or	ax, 33Fh
		mov	[ebp-0B5h], ax
		bt	dword ptr h_fcw[ebp], 3
		jc	short loc_9FC0
		and	word ptr [ebp-0B5h], 0FFF7h+FORCEBIG
loc_9FC0:	fldcw	word ptr [ebp-0B5h]
		bt	dword ptr h_fcw[ebp], 4
		jc	short loc_9FDC
		and	word ptr [ebp-0B5h], 0FFEFh+FORCEBIG
		fldcw	word ptr [ebp-0B5h]
loc_9FDC:	fmulp	st(1), st
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	al, 8
		jz	short loc_9FFA
		bts	dword ptr h_fsw[ebp], 3
		bt	dword ptr h_fcw[ebp], 3
		jc	short loc_A047
		jmp	short loc_A00A

loc_9FFA:	test	al, 10h
		jz	short loc_A047
		bts	dword ptr h_fsw[ebp], 4
		bt	dword ptr h_fcw[ebp], 4
		jc	short loc_A047
loc_A00A:	fnclex	
		mov	eax, h_fcfg[ebp]
		and	eax, 0FFFFFFF7h
		mov	h_fcfg[ebp], eax
		or	eax, 200h
		mov	[ebp-0B3h], eax
		DELAYNOP 2
		FWRCFG	[ebp-0B3h]
		and	eax, 0FFFFFDFFh
		mov	[ebp-0B3h], eax
		FWRCFG	[ebp-0B3h]
loc_A047:	test	al, 20h
		jz	short loc_A055
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
loc_A055:	mov	word ptr [ebp-0B5h], 37Fh
		fldcw	word ptr [ebp-0B5h]
loc_A064:	fstp	tbyte ptr h_fr1[ebp]
		@CALL	loc_8F23
		fnrstor	byte ptr h_fenviron[ebp]
		fstp	st
		jmp	loc_8F53

loc_A07B:	@CALL	loc_8F23
		jmp	loc_8F53

		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end FYL2X.ASM