;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: SOFRES.ASM - 
; Date: 2004-09-11
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	SoftReset:near
 IF VVL
	extrn	loc_6AA8:near
 ENDIF

	public	loc_6520


		db '@(#)sofres.asm',TAB,'2.3',0
		ALIGN0	32

; Hypermode entry via offset 0880h
loc_6520:	mov	ebp, esp
		sub	ebp, 3E4h	; h_ebp, now EBP=0FFFF1400h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
	; v-- has no effect --v
		mov	eax, h_gatflag[ebp]
		and	eax, 3
		mov	eax, h_uart[ebp]
		cmp	al, 0
	; ^-- has no effect --^
		@CALL	loc_6577
		jmp	SoftReset

	; v-- unused --v
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
 IF VVL
		@CALL	loc_6AA8
 ELSE
		@CALL	loc_6563	; nonsense
 ENDIF
loc_6563:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH
	; ^-- unused --^

; reset EIP, EFL and ESP
; E:-
; V: EAX
; R:-
loc_6577:	mov	eax, h_inieip[ebp]
		mov	h_eip3[ebp], eax
		mov	dword ptr h_efl[ebp], 80000002h
		mov	dword ptr h_esp[ebp], 0
		@RET

		ALIGN	256

hypseg		ends
		end

;-------------------------------------------------------------- end SOFRES.ASM