;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FPTAN.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8F23:near
	extrn	loc_8F44:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FD3:near
	extrn	loc_902B:near
	extrn	loc_9097:near
	extrn	loc_90C1:near
	extrn	loc_90ED:near

	public	DecFPTAN

		db '@(#)fptan.asm',TAB,'3.2',0
		ALIGN0	32

loc_A0B0:	dt 0BFFC8895A6C5FB423BCAh	; -0.133383

loc_A0BA:	dt 3FF6E073D3FC199C4A00h	; 0.00342487

loc_A0C4:	dt 0BFEF95D52D44927821A8h	; -1.78615e-005

loc_A0CE:	dt 0BFFDEEF57E0DA84BC8CEh	; -0.466717

loc_A0D8:	dt 3FF9D23CD68415D95FA1h	; 0.0256638

loc_A0E2:	dt 0BFF3A37ACD9CDD32FA5Ah	; -0.000311813

loc_A0EC:	dt 3FEA85BACFA87C3442E9h	; 4.98182e-007

		dt 3FFFC90FDAA22168C235h	; 1.5708 = pi/2

DecFPTAN:	@CALL	loc_8E80
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 90h
		FNLDTW	h_ftw[ebp]
		FNLDSW	h_fsw[ebp]
		btr	dword ptr h_fsw[ebp], 10
		ffree	st(6)
		ffree	st(7)
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_A142
		jnc	short loc_A142
loc_A133:	@CALL	loc_902B
		jmp	loc_A2F1

loc_A142:	push	eax
		@CALL	loc_90ED
		cmp	cl, 1
		jz	loc_A2F1
		pop	eax
		sahf	
		jbe	short loc_A19D
		jnp	short loc_A18E
loc_A15C:	mov	byte ptr [ebp-92h], 0
		test	ah, 2
		jz	short loc_A171
		fabs	
		mov	byte ptr [ebp-92h], 80h
loc_A171:	fld	st
		fstp	tbyte ptr [ebp-90h]
		cmp	word ptr [ebp-88h], 403Eh
		jl	short loc_A1D6
		bts	dword ptr h_fsw[ebp], 10
		jmp	loc_A2CB

loc_A18E:	@CALL	loc_8FB3
		jmp	loc_A2F1

loc_A19D:	jc	short loc_A1A6
		jp	short loc_A1C8
		jmp	loc_A2AF

loc_A1A6:	jp	short loc_A1B9
		jz	short loc_A133
		@CALL	loc_8FD3
		jmp	loc_A2F1

loc_A1B9:	@CALL	loc_8FB3
		jmp	loc_A2F1

loc_A1C8:	push	eax
		@CALL	loc_9097
		pop	eax
		jmp	short loc_A15C

loc_A1D6:	lea	esi, [ebp-90h]
		mov	ecx, h_base[ebp]
		fninit	
		fld	tbyte ptr [esi]
		FNUNKNOWN1
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		fst	st(1)
		fstp	tbyte ptr [esi]
		and	byte ptr [esi+9], 7Fh
		shr	eax, 9
		and	al, 1
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
		cmp	word ptr [esi+8], 3FD9h
		jl	loc_A2D0
		fld	st
		fld	st(1)
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_A0C4[ecx]
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:loc_A0BA[ecx]
		faddp	st(1), st
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:loc_A0B0[ecx]
		faddp	st(1), st
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fmul	st, st(2)
		fstp	st(1)
		fstp	st(1)
		fadd	st, st(1)
		fxch	st(1)
		fld	st
		fld	st(1)
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_A0EC[ecx]
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:loc_A0E2[ecx]
		faddp	st(1), st
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:loc_A0D8[ecx]
		faddp	st(1), st
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:loc_A0CE[ecx]
		faddp	st(1), st
		fld	st(1)
		fmul	st, st(1)
		fstp	st(1)
		fld1	
		faddp	st(1), st
		fstp	st(1)
		fstp	st(1)
		fstp	st(1)
loc_A290:	test	al, 1
		jz	short loc_A29A
		fdiv	st, st(1)
		fstp	st(1)
		jmp	short loc_A2A0

loc_A29A:	fxch	st(1)
		fdiv	st, st(1)
		fstp	st(1)
loc_A2A0:	fstp	tbyte ptr h_fr0[ebp]
		shl	al, 7
		xor	al, [ebp-92h]
		xor	h_fr0[ebp+9], al
loc_A2AF:	fld1	
		fstp	tbyte ptr h_ftemp[ebp]
loc_A2B4:	@CALL	loc_8F23
		fnclex	
		fnrstor	byte ptr h_fenviron[ebp]
		fld	tbyte ptr h_ftemp[ebp]
		jmp	loc_8F53

loc_A2CB:	jmp	loc_8F44

loc_A2D0:	push	eax
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnp	short loc_A2EC
		jnz	short loc_A2EC
		@CALL	loc_90C1
loc_A2EC:	fld1	
		pop	eax
		jmp	short loc_A290

loc_A2F1:	fld	st
		fstp	tbyte ptr h_fr0[ebp]
		fstp	tbyte ptr h_ftemp[ebp]
		jmp	short loc_A2B4

		fclex	
		fnrstor	byte ptr h_fenviron[ebp]
		fld	tbyte ptr h_ftemp[ebp]
		fnsave	byte ptr h_fenviron[ebp]
		@RET

		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end FPTAN.ASM