;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: NP_EM.ASM - 
; Date: 2020-09-25
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8F23:near
	extrn	loc_8F44:near

	public	DecFSQRT

 IF V033S
		db '@(#)np_em.asm',TAB,'3.2',0
 ELSEIF V033V
		db '@(#)np_em   ',0
 ELSE
		db '@(#)np_em.asm',TAB,'3.3',0
 ENDIF
		ALIGN0	32

DecFSQRT:	@CALL	loc_8E80
		fsqrt	
		fnstenv	byte ptr h_fenviron[ebp]
		@CALL	loc_8F23
		jmp	loc_8F44

		mov	ebx, 2
		add	ebx, h_eip2[ebp]
		mov	h_eip3[ebp], ebx
		mov	h_eip2[ebp], ebx
		RDAR	eax, cs
		bts	eax, 19h
		OP_0FE4
		WRAR	cs, eax
		mov	ecx, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], ecx
 ENDIF
		xor	edx, edx
		mov	dr7, edx
		mov	al, cs:[ebx]
		mov	dr7, ecx
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end NP_EM.ASM