;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: XESC.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	Exception:near
	extrn	loc_3B35:near
	extrn	loc_6A20:near

	public	loc_3F20v
	public	loc_40FD
	public	loc_4133


		db '@(#)xesc    ',0
		ALIGN0	32

loc_3F20v:	and	h_gatflag[ebp], 70000FFh
		mov	eax, h_gatflag[ebp]
		and	al, 0Fh
		cmp	al, 1
		jz	loc_6A20
		bt	h_dbflag[ebp], 22
		jnc	short loc_3F46
		jmp	loc_3B35

loc_3F46:	cmp	al, 0Eh
		jnz	short loc_3F7E
		btr	h_dbflag[ebp], 23
		jc	short loc_3F6B
		bts	h_dbflag[ebp], 23
		mov	eax, cr3
		mov	cr3, eax
		@CALL	loc_40FD
		jmp	loc_4000

loc_3F6B:	mov	eax, cr2
		mov	h_cr2[ebp], eax
		@CALL	loc_4085
loc_3F7E:	bts	h_dbflag[ebp], 22
		@CALL	loc_40FD
		mov	eax, h_cfg1[ebp]
		btr	eax, 18
		mov	h_cfg1[ebp], eax
		OP_0FE4
		WRCFG1	eax
		mov	eax, 0FFFFFFFFh
		mov	cr2, eax
		jmp	short loc_4000

		ALIGN0	256

loc_4000:	mov	eax, h_cfg0[ebp]
		bts	eax, 31
		DELAYNOP 2
		WRCFG0	eax
		btr	h_efl[ebp], 16
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		mov	edx, dr7
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], edx
		xor	ecx, ecx
		mov	dr7, ecx
		mov	h_excph[ebp], offset Exception
		mov	ebx, h_eip2[ebp]
		RDAR	ecx, cs
		mov	eax, ecx
		bts	ecx, 25
		OP_0FE4
		WRAR	cs, ecx
		test	byte ptr cs:[ebx], 0
		OP_0FE4
		WRAR	cs, eax
		jmp	short loc_4068

loc_4068:	mov	dr7, edx
		btr	word ptr h_dbflag[ebp], 2
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_4085:	mov	esi, 0FFFFFFFFh
		mov	eax, [ebp+328h]
		mov	edx, eax
		and	eax, 0FFFh
		cmp	eax, 4
 IF V033V
		jge	short loc_40F1
 ELSE
		jc	short loc_40A3
		cmp	eax, 0FFCh
		jbe	short loc_40F1
 ENDIF

loc_40A3:	RDCPL	eax
		and	al, 3
		cmp	al, 3
		jnz	short loc_40F1
		sub	edx, 4
		@CALL	loc_4182
		cmp	ebx, 0
		jz	short loc_40F1
		@CALL	loc_4133
		@CALL	loc_414D
		mov	eax, ebx
		and	eax, 20h
		jz	short loc_40E7
		and	ebx, 0FFFFFFDFh
		mov	gs:[edx], ebx
		mov	esi, edx
		mov	eax, cr3
		mov	cr3, eax
loc_40E7:	mov	cr0, edi
		mov	al, 0
		OP_0FE4
		WRSBNK	eax
loc_40F1:	mov	[ebp+334h], esi
		@RET

; same as loc_24FE in INT.ASM for PCI
; set opcode mask to emulate all instructions
loc_40FD:	DELAYNOP 2
		LOPCMSK	 0, 0FFh
		LOPCMSK	 1, 0FFh
		LOPCMSK	 2, 0FFh
		LOPCMSK	 3, 0FFh
		LOPCMSK	 4, 0FFh
		LOPCMSK	 5, 0FFh
		LOPCMSK	 6, 0FFh
		LOPCMSK	 7, 0FFh
		@RET

loc_4133:	mov	eax, cr0
		mov	edi, eax
		and	eax, 7FFFFFFFh
		mov	cr0, eax
		mov	al, 1
		OP_0FE4
		WRSBNK	eax
		@RET

loc_414D:	push	ecx
		mov	ecx, cr3
		and	ecx, 0FFFFF000h
		mov	eax, edx
		shr	eax, 22
		shl	eax, 2
		add	ecx, eax
		mov	ecx, gs:[ecx]
		and	ecx, 0FFFFF000h
		shr	edx, 12
		and	edx, 3FFh
		shl	edx, 2
		add	edx, ecx
		mov	ebx, gs:[edx]
		pop	ecx
		@RET

loc_4182:	mov	ebx, tr7
		push	ebx
		mov	ebx, tr6
		push	ebx
		mov	eax, edx
		and	eax, 0FFFFF000h
		or	eax, 0FE1h
		mov	tr6, eax
		mov	ebx, tr7
		bt	ebx, 4
		jnc	short loc_41B8
		and	eax, 0FFFFF000h
		or	eax, 0F41h
		mov	tr6, eax
		mov	ebx, tr7
		bt	ebx, 4
		jnc	short loc_41BA
loc_41B8:	xor	ebx, ebx
loc_41BA:	pop	eax
		or	eax, 1
		mov	tr6, eax
		pop	eax
		mov	tr7, eax
		@RET

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end XESC.ASM